program inv
use sep
use rad_trans_mod
use cgstep_mod
use solver_mod
implicit none
 
integer                 		  :: niter, nt, nx, nv, ns, is
real                    		  :: dt, ot, dx, ox, dv, ov 
real, allocatable,dimension (:)  	  :: model, data

  call sep_init()
  call from_history("n1",nt)
  call from_history("o1",ot)
  call from_history("d1",dt)
  call from_history("n2",nv)
  call from_history("o2",ov)
  call from_history("d2",dv)
  call from_history("n3",ns)

  call from_param("niter",niter)

  nx = 564
  dx = 12.5
  ox = 167

  allocate(model(nt*nx))
  allocate(data(nt*nv))
  model = 0.
  data = 0.

  call rad_trans_init(nt, nx, nv, ot, ox, ov, dt, dx, dv )
  do is=1,ns
    call sep_read(data)
    call solver_tiny(model,data,rad_trans_op,cgstep,niter)
    call sep_write(model)
  end do


  call to_history("n2", nx)
  call to_history("o2", ox)
  call to_history("d2", dx)
  call to_history("label2", 'Offset [m]')
  call sep_close()
end program
