module rad_trans_mod

implicit none
integer, private		:: nt, nx, nv
real, private    		:: ot, ox, ov, dt, dx, dv

contains



subroutine rad_trans_init(nt_in, nx_in, nv_in, ot_in, ox_in, ov_in, dt_in, dx_in, dv_in )
integer           		:: nt_in, nx_in, nv_in
real               		:: ot_in, ox_in, ov_in, dv_in, dx_in, dt_in
nt = nt_in
ot = ot_in
dt = dt_in

nx = nx_in
ox = ox_in
dx = dx_in

nv = nv_in
dv = dv_in
ov = ov_in
end subroutine



function rad_trans_op(adj, add, model, data) result(stat)
logical,intent(in) 		:: adj, add !,intent(in)
real,dimension(:)  		:: model, data
integer           		:: stat
 call rad_trans(adj, add, model, data)
stat=0
end function



subroutine rad_trans(adj, add, model, data)
logical,intent(in) 		:: adj, add 
real, dimension(nt,nx)  	:: model
real, dimension(nt,nv) 		:: data
integer				:: iv,it,ix
real				:: vel, x, xx, t, wtb, wtt




if(adj) then
if(.not. add) model=0.
do iv=1,nv
	vel = ov + (iv-1)*dv
	do it=1,nt
		t = ot + (it-1)*dt
		x = vel*t
		if(x>=ox) then
		xx = ((x-ox)/dx)+1
		ix = xx
		if((ix+1)<=nx) then
			wtt = xx - ix
			wtb = (ix + 1) - xx
			model(it,ix) = model(it,ix) + data(it,iv)*wtb
			model(it,ix+1) = model(it,ix+1) + data(it,iv)*wtt
		end if
		end if
	end do
end do
else
if(.not. add) data=0.
do iv=1,nv
	vel = ov + (iv-1)*dv
	do it=1,nt
		t = ot + (it-1)*dt
		x = vel*t
		if(x>=ox) then
		xx = ((x-ox)/dx)+1
		ix = xx
		if((ix+1)<=nx) then
			wtt = xx - ix
			wtb = (ix + 1) - xx
			data(it,iv) = data(it,iv) + model(it,ix)*wtb
			data(it,iv) = data(it,iv) + model(it,ix+1)*wtt
		end if
		end if
	end do
end do
end if


end subroutine
end module 
