
program radial_trans
use sep
use rad_trans_mod
implicit none
 
integer                 		  :: fac, nt, nx, nv, ns, is
real                    		  :: maxvel, ot, ox, ov, dt, dx, dv 
real, allocatable,dimension (:,:)  	  :: model, data

  call sep_init()
  call from_param("fac",fac)
  call from_param("maxvel",maxvel)
  call from_history("n1",nt)
  call from_history("o1",ot)
  call from_history("d1",dt)

  call from_history("n2",nx)
  call from_history("o2",ox)
  call from_history("d2",dx)

  call from_history("n3",ns)


  nv = fac + 1
  ov = 24.4
  dv = (maxvel-ov)/fac

  call rad_trans_init(nt, nx, nv, ot, ox, ov, dt, dx, dv )

  allocate(model(nt,nx))
  allocate(data(nt,nv))
  model = 0.
  data = 0.

  do is=1,ns
    call sep_read(model)
    call rad_trans(.false., .false., model, data)
    call sep_write(data)
  end do


  call to_history("label1",'Time [s]')
  call to_history("n2",nv)
  call to_history("o2",ov)
  call to_history("d2",dv)
  call to_history("label2",'Velocity [m/s]')
  call to_history("n3",ns)

  call sep_close()
end program

