
program radial_trans_inv
use sep
use rad_trans_mod
implicit none
 
integer                 		  :: nt, nx, nv, ns, is
real                    		  :: dt, ot, dx, ox, dv, ov 
real, allocatable,dimension (:,:)  	  :: model, data

  call sep_init()
  call from_history("n1",nt)
  call from_history("o1",ot)
  call from_history("d1",dt)

  call from_history("n2",nv)
  call from_history("o2",ov)
  call from_history("d2",dv)

  call from_history("n3",ns)


  nx = 564
  dx = 12.5
  ox = 167

  call rad_trans_init(nt, nx, nv, ot, ox, ov, dt, dx, dv )

  allocate(model(nt,nx))
  allocate(data(nt,nv))
  model = 0.
  data = 0.

  do is=1,ns
    call sep_read(data)
    call rad_trans(.true., .false., model, data)
    call sep_write(model)
  end do

  call to_history("label1",'Time [s]')
  call to_history("n2",nx)
  call to_history("o2",ox)
  call to_history("d2",dx)
  call to_history("label2",'Offset [m]')
  call to_history("n3",ns)

  call sep_close()
end program

